; space game demo -by Matt Teiken
#include "asm86.h"        ;We need this stuff for most games
#include "ti86asm.inc"
#include ti86abs.inc
Stars = $C128
Pbullets = $C230
PbDir = $C270
ELoc = $C290

.org _asm_exec_ram
_homeup         equ       4A95h  
_flushallmenus  equ     49DCh   ; clear the 86's menu key stacks
;----------------------
	nop
	jp Startup
.dw 0000                 ;Ashell stuff
.dw title
title:
.db "Space Demo Matt Teiken",0
;----------------------
Startup:
 call _flushallmenus  ;let's flush those menus.
 call BUSY_OFF        ;Turn that damn thing off!
 call _clrLCD
 call ClearStars
 call DisplayStars
 call DisplayPbullets
 call DispEnemies
 call LoadP
_homeup         equ       4A95h       ; cursror to top left of home screen
MainLoop:

 call GetInput

 ld a,(Pbspeed)
 ld b,a
 ld a,(Pbtimer)
 inc a
 ld (Pbtimer),a
 cp b
 jp nz,skipPb
 xor a
 ld (Pbtimer),a
 call DisplayPbullets
 call MovePbullets
 call DisplayPbullets

skipPb:
 ld a,(Sspeed)
 ld b,a
 ld a,(Stimer)
 inc a
 ld (Stimer),a
 cp b
 jp nz,skipStars
 xor a
 ld (Stimer),a
 call DisplayStars
 call MoveStars
 call DisplayStars

skipStars:
 ld a,(Etimer)
 inc a
 ld (Etimer),a
 ld b,a
 ld a,(Espeed)
 cp b
 jp nz,skipEnemies
 xor a
 ld (Etimer),a
 call DispEnemies
 call MoveEnemies
 call NewEnemy?
 call DispEnemies
skipEnemies:

 call GET_KEY
 cp K_EXIT
 jp z,Exit
 cp K_PLUS
 jp z,incs
 cp K_MINUS
 jp z,decs
 cp K_MORE
 jp z,GunC
 jp MainLoop
GunC:
 ld a,5
 call random
 ld (Gun),a
 xor a
 ld (GunTimer),a
 jp MainLoop
incs:
 xor a
 ld (Stimer),a
 ld a,(Sspeed)
 cp 10
 jp z,MainLoop
 sub 10
 ld (Sspeed),a
 jp MainLoop
decs:
 xor a
 ld (Stimer),a
 ld a,(Sspeed)
 cp 250
 jp z,MainLoop
 add a,10
 ld (Sspeed),a
 jp MainLoop

Exit:
 call _clrLCD
 call _homeup
 ret

NewEnemy?:
 ld a,35
 call random
 cp 3
 jp nz,break
 ld d,0
 ld e,0
NewE2:
 ld hl,ELoc
 add hl,de
 ld a,(hl)
 cp 0
 jp z,AddNE
 ld a,e
 add a,2
 ld e,a
 cp 30
 jp z,break
 jp NewE2
AddNE:
 ld a,5
 call random
 add a,115
 ld (hl),a
 inc hl
 ld a,56
 call random
 inc a
 ld (hl),a
 ret


MoveEnemies:
 ld d,0
 ld e,0
MvE2:
 ld hl,ELoc
 add hl,de
 ld a,(hl)
 cp 0
 jp z,NextMvE
 dec a
 ld (hl),a
NextMvE:
 ld a,e
 add a,2
 ld e,a
 cp 30
 jp z,break
 jp MvE2

DispEnemies:
 ld d,0
 ld e,0
DispE2:
 ld hl,ELoc
 add hl,de
 ld a,(hl)
 ld b,a
 cp 0
 jp z,NextE
 inc hl
 ld a,(hl)
 ld c,a
 call PutE
NextE:
 ld a,e
 add a,2
 ld e,a
 cp 30
 jp z,break
 jp DispE2

PutE:
 ld hl,EnemyPics
 call PutSprite
 ret

DisplayPbullets:
 ld d,0
 ld e,0
DispPbull:
 ld hl,Pbullets
 add hl,de
 ld a,(hl)
 cp 126
 jp z,NextPbull
 ld b,a
 inc hl
 ld a,(hl)
 ld c,a
 call PutPb
NextPbull:
 inc e
 inc e
 ld a,e
 cp 20
 jp z,break
 jp DispPbull

MovePbullets:
 ld d,0
 ld e,0
MovePbullets2:
 ld hl,PbDir
 add hl,de
 ld a,(hl)
 cp 1
 jp z,PbUR
 cp 2
 jp z,PbRight
 cp 3
 jp z,PbDR
 ret

PbUR:
 ld hl,Pbullets
 add hl,de
 ld a,(hl)
 cp 126
 jp z,NextMovePb
 inc a
 ld (hl),a
 inc hl
 ld a,(hl)
 cp 0
 jp nz,ContUR
 dec hl
 ld (hl),126
 jp NextMovePb
ContUR:
 ld a,(hl)
 dec a
 ld (hl),a
 jp NextMovePb

PbDR:
 ld hl,Pbullets
 add hl,de
 ld a,(hl)
 cp 126
 jp z,NextMovePb
 inc a
 ld (hl),a
 inc hl
 ld a,(hl)
 cp 62
 jp nz,ContDR
 dec hl
 ld (hl),126
 jp NextMovePb
ContDR:
 ld a,(hl)
 inc a
 ld (hl),a
 jp NextMovePb

PbRight:
 ld hl,Pbullets
 add hl,de
 ld a,(hl)
 cp 126
 jp z,NextMovePb
 inc a
 ld (hl),a
 jp NextMovePb

NextMovePb:
 inc e
 inc e
 ld a,e
 cp 20
 jp z,break
 jp MovePbullets2

MoveStars:
 ld e,0
 ld d,0
MoveS2:
 ld hl,Stars
 add hl,de
 ld a,(hl)
 cp 0
 jp nz,contMoveS2
 call New
contMoveS2:
 dec a
 ld (hl),a
 inc e
 inc e
 ld a,e
 cp 50
 jp z,break
 jp MoveS2
New:
 ld a,15
 call random
 add a,113
 ld (hl),a
 inc hl
 ld a,64
 call random
 ld (hl),a
 ret

DisplayStars:
 ld e,0
 ld d,0
DisplayS2:
 ld hl,Stars
 add hl,de
 ld a,(hl)
 ld b,a
 inc e
 ld hl,Stars
 add hl,de
 ld a,(hl)
 ld c,a
 call PixelInv
 inc e
 ld a,e
 cp 48
 jp z,break
 jp DisplayS2

ClearStars:
 ld d,0
 ld e,0
ClearStars2:
 ld hl,Stars
 add hl,de
 ld a,128
 call random
 ld (hl),a
 inc e
 ld hl,Stars
 add hl,de
 ld a,64
 call random
 ld (hl),a
 ld a,e
 inc e
 cp 49
 jp z,ClearPbullets
 jp ClearStars2

ClearPbullets:
 ld d,0
 ld e,0
CPbull:
 ld hl,Pbullets
 add hl,de
 ld (hl),126
 inc e
 ld a,e
 cp 19
 jp z,ClearEloc
 jp CPbull
ClearEloc:
 ld d,0
 ld e,0
CEloc2:
 ld hl,ELoc
 add hl,de
 ld (hl),0
 inc hl
 ld (hl),0
 ld a,e
 add a,2
 ld e,a
 cp 32
 jp z,break
 jp CEloc2


break:
 ret


;------------------------------------------------------
;   FIND PIXEL ROUTINES by CLEM <clems@mygale.org>
;
;       Input:  x->b
;               y->c
;
;       Output: hl : byte in LCD memory
;               a  : bitmask for (hl)
;
;       If you need speed, use FindPixel, else
;       use Find_Pixel (shorter).
;
;---------------------- examples ----------------------

PixelOn:
            call Find_Pixel
            or (hl)
            ld (hl),a
            ret

PixelOff:
            call Find_Pixel
            cpl
            and (hl)
            ld (hl),a
            ret

PixelInv:
            call Find_Pixel
            xor (hl)
            ld (hl),a
            ret

PutPb:
	call PixelInv
    inc b
    call PixelInv
    inc c
    call PixelInv
    dec b
    call PixelInv
    ret

PixelTest:
            call Find_Pixel
            and (hl)
            ret

;------------------------------------------------------
;   FIND_PIXEL by CLEM
;
;   121 cycles  27 bytes    Destroyes : none
;------------------------------------------------------

Find_Pixel:
    ld h,63
    ld a,c
    add a,a
    add a,a
    ld l,a
    ld a,b
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld a,b
    and 7
    cpl
    rlca
    rlca
    rlca
    ld (FP_Bit+1),a
    xor a
FP_Bit:
    set 0,a
    ret

;------------------------------------------------------
;   FINDPIXEL by CLEM
;
;   117 cycles  34 bytes    Destroyes : bc
;------------------------------------------------------

FindPixel:
    ld h,63
    ld a,c
    add a,a
    add a,a
    ld l,a
    ld a,b
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld a,b
    and 7
    ld bc,FP_Bits
    add a,c
    ld c,a
    adc a,b
    sub c
    ld b,a
    ld a,(bc)
    ret

FP_Bits:    .db $80,$40,$20,$10,$08,$04,$02,$01

;------------------------------------------------------

    +-----------------------------------------+
    |     name : CLEM                         |
    | homepage : http://www.mygale.org/~clems | <-- french
    |   e-mail : mailto:clems@mygale.org      |
    +-----------------------------------------+
random: 	       ; Creates a random number 0 <= x < A
 	push bc
 	push de
 	push hl
 	ld b,a
 	ld a,r
 	add a,a
 	ld hl,0
 	ld d,0
 	ld e,a
RMul:
 	add hl,de
 	djnz RMul
 	ld a,h
 	pop hl
 	pop de
 	pop bc
 	ret

pause:
    call GET_KEY             ;gets the recent key pressed
    cp K_EXIT                ;compare it to exit
    jp z,break               ;if it's exit, go to break (ret)
    cp K_SECOND               ;and similar
    jp z,break
    cp K_ENTER               ;and similar
    jp z,break
    jp pause

Delay:
 ld a,30
Delay2:
 dec a
 cp 0
 jp z,Delay3
 jp Delay2
Delay3:
 ld a,b
 dec a
 ld b,a
 cp 0
 jp nz,Delay
 ret

GetInput:
 ld a,(Itimer)
 inc a
 ld (Itimer),a
 ld b,a
 ld a,(Ispeed)
 cp b
 jp nz,break
 xor a
 ld (Itimer),a

 ld a,(Shtimer)
 inc a
 ld (Shtimer),a
 ld b,a
 ld a,(Shspeed)
 cp b
 jp nz,CheckDown
 xor a
 ld (Shtimer),a

 ld a,$BF
 out (1),a
 nop
 nop
 in a,(1)
 bit 5,a	       ; Check if the 2nd key is being pressed
 jp nz,CheckDown      ;  
 call NewPbullet

CheckDown:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)
 bit 0,a	      
 jp nz,CheckUp
 call MoveDown
CheckUp:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)      
 bit 3,a	      
 jp nz,CheckLeft
 call MoveUp
CheckLeft:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)
 bit 1,a	      
 jp nz,CheckRight
 call MoveLeft
CheckRight:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)      
 bit 2,a  
 jp nz,break
 call MoveRight
 ret

MoveUp:
 ld a,(py)
 cp 0
 jp z,break
 call LoadP
 ld a,(py)
 dec a
 ld (py),a
 call LoadP
 ret
MoveDown:
 ld a,(py)
 cp 56
 jp z,break
 call LoadP
 ld a,(py)
 inc a
 ld (py),a
 call LoadP
 ret

MoveLeft:
 ld a,(px)
 cp 0
 jp z,break
 call LoadP
 ld a,(px)
 dec a
 ld (px),a
 call LoadP
 ret
MoveRight:
 ld a,(px)
 cp 104
 jp z,break
 call LoadP
 ld a,(px)
 inc a
 ld (px),a
 call LoadP
 ret

NewPbullet:
 ld d,0
 ld e,0
NewPbullet2:
 ld hl,Pbullets
 add hl,de
 ld a,(hl)
 cp 126
 jp z,AddNewPb
 inc e
 inc e
 ld a,e
 cp 20
 jp z,break
 jp NewPbullet2

AddNewPb:
 ld a,(px)
 add a,8
 ld (hl),a
 ld b,a
 ld a,(py)
 add a,3
 inc hl
 ld (hl),a
 ld c,a
 call PutPb
 ld hl,PbDir
 add hl,de
 call GetGun
 ld (hl),a
 ret

GetGun:
 ld a,(Gun)
 cp 0
 jp z,Gun0
 cp 1
 jp z,Gun1
 cp 2
 jp z,Gun2
 cp 3
 jp z,Gun3
 cp 4
 jp z,Gun4
Gun0:
 ld a,2
 ret
Gun1:
 ld a,2
 call random
 inc a
 cp 1
 jp z,break
 ld a,3
 ret 
Gun2:
 ld a,3
 call random
 inc a
 ret
Gun3:
 ld a,(GunTimer)
 cp 1
 jp z,GUp
 jp GDown
 ret 
Gun4:
 ld a,(GunTimer)
 cp 2
 jp z,GUp
 cp 1
 jp z,GDown
 inc a
 ld (GunTimer),a
 ld a,2
 ret

GUp:
 xor a
 ld (GunTimer),a
 ld a,1
 ret
GDown:
 inc a
 ld (GunTimer),a
 ld a,3
 ret

LoadP:
 ld a,(py)      ;load x variable into a
 ld c,a 
 ld a,(px)      
 ld b,a
 ld hl,PPic   
 call PutSprite ;Put Pic at (c,b)
 ret

PutSprite: ;I didn't make this but I'm beginning to understand how it works.
;FastSprite_______________________________
;Input: Sprite in (HL), (b,c)            |
;Output: Sprite xor'ed onto the screen   |
;Destroyed: none                         |
;-----------------------------------------
	push af
	push bc
	push de
	push ix
	push hl
	push hl                 ;\
	pop ix                  ; > hl -> ix
	ld hl, FSByte           ;> point to Tempbyte
	ld (hl), c              ;> put c into Byte for later use
	ld a, b
	rrca                    ;\
	rrca                    ; > divide x by 8 in accumulator
	rrca                    ;/                      
	rld                     ;> Rotate left 4 bytes  
	or $FC                  ;> add a and $FC
	ld l, (hl)              ;\
	ld h, a                 ; > buncha loading going on
	ld a, b                 ;/
	and 7                   ;> mask out the shift number
	ld d, a                 ;> save the shift number
	ld e, 8
FSLoop:                         
	ld a, (ix)              ;> get sprite data
	ld b, a
	inc ix                  ;> point to new sprite data byte
	ld c, 0                 ;> clear c for shift use
	ld a, d                 ;> restore shift # for use
	cp 0
	jp z, NoShift
	ld a, b
	ld b, d
FSShift:
	srl a                   ;\
	rr c                    ; \
	dec b                   ;  > shift until b < 0
	jp z, Shiftend          ; /
	jp FSShift              ;/
NoShift:
	ld a, b
Shiftend:
	xor (hl)                ;> mix the shifted sprite w/screen
	ld (hl), a              ;> and draw it to the screen
	inc hl                  ;> hl points to next screen byte
	ld a, c                 ;> accumulate the remaining shifted data
	xor (hl)                ;> mix 'em
	ld (hl), a              ;> draw it
	ld a, 15                ;\
	add a, l                ; \
	ld l, a                 ;  > Inc the <HL> 1 y value.
	jp nc, FSNoinc          ; /
	inc h                   ;/
FSNoinc:
	dec e                   ; >check if loop is finished
	jp nz, FSLoop           ;/
    pop hl                  ;\
	pop ix                  ; \
	pop de                  ;  > mmmpop boop be doop mmmpop
	pop bc                  ; /  
	pop af                  ;/
	ret
FSByte: 
        .db $00


py:
.db 20
px:
.db 50
Sspeed:
.db 100
Stimer:
.db 0
Shspeed:
.db 2
Shtimer:
.db 0
Ispeed:
.db 50
Itimer:
.db 0
Espeed:
.db 70
Etimer:
.db 0
Pbspeed:
.db 40
Pbtimer:
.db 0
Gun: ;Type of gun the player has
.db 0
GunTimer: ;Stage of firing that the gun is in
.db 0
PPic:
	.db %11111111
	.db %01110000
	.db %11011100
	.db %11101111
	.db %11101111
	.db %11011100
	.db %01110000
	.db %11111111

EnemyPics:
	.db %01111100
	.db %11011010
	.db %10001101
	.db %11011111
	.db %11111011
	.db %10110001
	.db %01011011
	.db %00111110

.end
